
                                                         (* 11.4.1997   *)
{
  Schnitt zweier Kreise: Die quadratischen Glieder der zwei allgemeinen
  Kreisgleichungen fallen weg, wenn man die beiden Gleichungen voneinander
  subtrahiert. Man bekommt eine lineare Gleichung, naemlich die Gleichung
  der Chordalen oder Potenzlinie zweier Kreise. Diese Gerade schneidet man
  dann mit einem der beiden Kreise.

  I    (x - M1X)^2 + (y - M1Y)^2 = R1^2                          Kreis1
  II   (x - M2X)^2 + (y - M2Y)^2 = R2^2                          Kreis2
  --------------------------------------------------------
  Gleichungen ausquadrieren:
  I    x^2 -2*x*M1X + M1X^2 + y^2 - 2*y*M1Y + M1Y^2 = R1^2
  II   x^2 -2*x*M2X + M2X^2 + y^2 - 2*y*M2Y + M2Y^2 = R2^2
  --------------------------------------------------------
  I - II:
  (2*M2X-2*M1X)*x + (2*M2Y-2*M1Y)*y = M2X^2-M1X^2+M2Y^2-M1Y^2+R1^2-R2^2
        A                 B                         C
  Das sind bereits die Koeffizienten der Potenzlinie.
                                                                          }

PROGRAM IntCircles;                        
USES CRT,UNIGRA12;

CONST
Eps = 1.0E-12;

TYPE
Line2D = RECORD                                                     
             O: Pt2D;
             U: Vt2D;
           END;

Circle = RECORD                                                      
             M: Pt2D;
             R: EXTENDED;
           END;

VAR
K1,K2       : Circle;                    (* Kreis                         *) 
PotLine     : Line2D;                    (* Linie                         *)
T1,T2       : EXTENDED;                  (* Parameter der Geraden =       *)
                                         (* Loesungen der quadr. Gleich.  *)
S1,S2       : Pt2D;                      (* Schnittpunkte                 *)
NoSH         : INTEGER;                  (* number of solutions = Anzahl  *)
                                         (* der Loesungen 1, 2 oder 0 =   *)
                                         (* kein Schnittpunkt             *)
Intsec      : BOOLEAN;
 
{ ------------------------- Unterprogramme ------------------------------ }
Procedure Ausgangszustand_definieren;
   BEGIN
   Plotter_einschalten;
   Graphik_einschalten('');
   Weltgrenzen_festlegen(einh);  
   Viewport_festlegen;
   GeraetefensterPlotter_festlegen;
   Parameter2D;
   Portrait  := FALSE;                   (* Querformat Bild liegend        *)
   Plast.X := WI2D[1].X;                 (* letzter Punkt initialisieren   *)
   Plast.Y := WI2D[1].Y;
   Viewport_zeichnen; 
   Koordinatenachsen_zeichnen;
   Gitter(0.05,1.0,1.0);(* Strich,              klE,             grE     *)
                       (* grosse Strichlaenge,kleine Einheit, grosse Einh *)
  END;

Procedure Beschriftung;
  VAR
  T: Ttyp;
  XUntergr,XObergr,YUntergr,YObergr,einhS,SXS,SYS     : STRING[Bz1];
  K1MXS,K1MYS,K2MXS,K2MYS,R1S,R2S,S1XS,S1YS,S2XS,S2YS : STRING[Bz1];
  Ttemp1,Ttemp2: STRING[Bz2];
  BEGIN
  STR(WI2D[1].X:5:1,XUntergr); STR(WI2D[1].Y:5:1,YUntergr);
  STR(WI2D[2].X:5:1,XObergr);  STR(WI2D[2].Y:5:1,YObergr);
  STR(einh:5:3,einhS);
  STR(K1.M.X:5:3,K1MXS); STR(K1.M.Y:5:3,K1MYS); STR(K1.R:5:3,R1S);
  STR(K2.M.X:5:3,K2MXS); STR(K2.M.Y:5:3,K2MYS); STR(K2.R:5:3,R2S);
  STR(S1.X:5:3,S1XS); STR(S1.Y:5:3,S1YS);
  STR(S2.X:5:3,S2XS); STR(S2.Y:5:3,S2YS);

(* ----------------------------- TEXTE --------------------------------- *)
  Ttemp1:= 'Schnitt zweier Kreise: M1('+K1MXS+'/'+K1MYS+') R1 '+R1S;
  Ttemp2 := '   M2('+K2MXS+'/'+K2MYS+') R2 '+R2S;
  T[1] := Ttemp1 + Ttemp2;
  CASE NoSH  OF
    0: BEGIN T[2] := 'Kreise schneiden nicht'; END;
    1: BEGIN Ttemp1 := 'Die Kreise beruehren einander im Punkt: (';
             Ttemp2 := S1XS + '/' + S1YS + ')';
             T[2]   := Ttemp1+Ttemp2;
       END;
    2: BEGIN Ttemp1 := '2 Schnittpunkte:  Punkt1:('+ S1XS + '/' + S1YS + ')';
             Ttemp2 := '    Punkt2:('+ S2XS + '/' + S2YS + ')';
             T[2]   := Ttemp1+Ttemp2;
       END;
  END;
        Ttemp1 := 'Weltgrenzen: X von '+XUntergr+' bis '+XObergr;
        Ttemp2 := '   Y von '+YUntergr+' bis '+YObergr;
  T[3] := Ttemp1 + Ttemp2;
  T[4] := '1 Einheit entspricht '+einhS+'  cm';
  Text_ausgeben(T,4);                                 (* .. Texte ausgeben *)
  END;

PROCEDURE SquareEquation(A,B,C: EXTENDED; VAR NOS: INTEGER;
                         VAR T1,T2: EXTENDED);
CONST
Eps1 = 1.0E-6;             (* muss groesser als allgemeinenes Epsilon sein *)
                           (* bestimmt die Tangentengenauigkeit            *)
VAR
D,TC: EXTENDED;
BEGIN
  CASE Null(A,Eps1) OF
    TRUE: BEGIN
      IF Null(B,Eps1) THEN NOS:=0
      ELSE BEGIN NOS:=1; T1:=-C/B; T2:=T1; END;
    END;
    FALSE: BEGIN
      D:=B*B-4*A*C;
      IF Null(D,Eps1) THEN BEGIN
        NOS:=1 ;
        T1:=-B/2/A; T2:=T1;
      END
      ELSE BEGIN
        IF D>0 THEN BEGIN
          NOS:=2;
          T1:=(-B+SQRT(D))/2/A;
          T2:=(-B-SQRT(D))/2/A;
          IF T1>T2 THEN BEGIN
            TC:=T1; T1:=T2; T2:=TC;
          END;
        END
        ELSE NOS:=0;
      END;
    END;
  END;
END;

PROCEDURE MakeVt2d(P1,P2: Pt2D; VAR V: Vt2D);
  BEGIN
   V.X := P2.X - P1.X;
   V.Y := P2.Y - P1.Y;
  END;

PROCEDURE LengthVt2D(V: Vt2D; VAR L: EXTENDED);
BEGIN
  L := SQRT(SQR(V.X)+SQR(V.Y)+Eps);
END;

PROCEDURE ScaleVt2D(V: Vt2D; LG: EXTENDED; VAR ScalV: Vt2D);
VAR L: EXTENDED;
BEGIN
  ScalV:=V;
  LengthVt2D(V, L);
  IF NOT Null(L,Eps) THEN BEGIN
    ScalV.X:=V.X/L*LG;
    ScalV.Y:=V.Y/L*LG;
  END;
END;

PROCEDURE SumVt2d(V1,V2:Vt2D; VAR V: Vt2D
);
  BEGIN
   V.X := V1.X + V2.X;
   V.Y := V1.Y + V2.Y;
  END;

PROCEDURE DifferenceVt2D(V1,V2: Vt2D; VAR DV: Vt2D);
BEGIN
  DV.X:=V1.X-V2.X;
  DV.Y:=V1.Y-V2.Y;
END;

PROCEDURE LinearCombinationVt2D(S1,S2: EXTENDED; V1,V2: Vt2D; VAR LC: Vt2D);
BEGIN
  LC.X:=S1*V1.X+S2*V2.X;
  LC.Y:=S1*V1.Y+S2*V2.Y;
END;

PROCEDURE ScalarProductVt2D(V1,V2: Vt2D; VAR SP: EXTENDED);
BEGIN
  SP:=V1.X*V2.X+V1.Y*V2.Y;
END;

PROCEDURE TToLine2D(Ln2D: Line2D; T: EXTENDED; VAR P: Pt2D);
BEGIN
  LinearCombinationVt2D(1,T,Ln2D.O,Ln2D.U, P);
END;

PROCEDURE IntersectionLineCircle(Ln2D: Line2D; Kreis: Circle;
                                 VAR NOS: INTEGER; VAR T1,T2: EXTENDED;
                                 VAR S1,S2: Pt2D);
VAR MO2,MOU,A,B,C: EXTENDED;
    MO: Vt2D;
BEGIN
  DifferenceVt2D(Ln2D.O,Kreis.M, MO);
  ScalarProductVt2D(MO,MO, MO2);
  ScalarProductVt2D(MO,Ln2D.U, MOU);
  A := 1; B := 2*MOU; C := MO2-SQR(Kreis.R);
  SquareEquation(A,B,C, NOS,T1,T2);
  IF NOS>0 THEN BEGIN
    TToLine2D(Ln2D,T1, S1);
    TToLine2D(Ln2D,T2, S2);
  END;
END;

PROCEDURE IntersectionLines2D(Line1,Line2: Line2D; VAR Intsec: BOOLEAN;
                              VAR T1,T2: EXTENDED; VAR S: Pt2D);
VAR Num,Den: EXTENDED;
    N2,DV: Vt2D;
    V: Vt2D;
BEGIN
  Intsec := FALSE;
  N2.X := Line2.U.Y; N2.Y := -Line2.U.X;
  DifferenceVt2D(Line1.O, Line2.O, DV);
  ScalarProductVt2D(DV,N2, Num);
  ScalarProductVt2D(Line1.U,N2, Den);
  IF NOT Null(Den,Eps) THEN BEGIN
    T1 := -Num/Den;
    TToLine2D(Line1,T1, S);
    DifferenceVt2D(S,Line2.O, V);       (* nicht mehr notwendig, nur mehr *)
    ScalarProductVt2D(V,Line2.U, T2);   (* zur Berechnung von t2          *)
    Intsec := TRUE;
  END;
END;

PROCEDURE In_Parameterform(A,B,C: EXTENDED;VAR Line: Line2D);
  BEGIN
    Line.U.X :=  B;                               (* Richtungsvektor       *)
    Line.U.Y := -A;                               (* Orientierung beliebig *)
                                                  (* Line.U.X :=  -B;      *)
                                                  (* Line.U.Y :=   A;      *)
                                                  (* auch moeglich !!!     *)
                                                  (* Richtungsvektor       *)
    ScaleVt2D(Line.U,1,Line.U);                   (* auf Einheitsvektor    *)
                                                  (* fixen Punkt bestimmen *)
    IF Null(A,Eps) THEN BEGIN                     (* Parallele zur X-Achse *)
      Line.O.Y := C/B;
      Line.O.X := 0.0;                                (* beliebig waehlbar *)
    END;
    IF Null(B,Eps) THEN BEGIN                     (* Parallele zur Y-Achse *)
      Line.O.X := C/A;
      Line.O.Y := 0.0;                                (* beliebig waehlbar *)
    END;
    IF ((NOT Null(A,Eps)) AND (NOT Null(B,Eps))) THEN BEGIN
      Line.O.X :=  0.0;                               (* beliebig waehlbar *)
      Line.O.Y :=  C/B;
    END;
  END;

PROCEDURE Chordale(K1,K2 : Circle; VAR PotLine : Line2D);
   VAR
   A,B,C : EXTENDED;                          (* Koeffizienten der Gerade *)
   M1X,M1Y,R1,M2X,M2Y,R2 : EXTENDED;          (* nur zur Sicherheit !     *)
   PotH : Line2D;
   BEGIN
     M1X := K1.M.X; M1Y := K1.M.Y; R1 := K1.R;
     M2X := K2.M.X; M2Y := K2.M.Y; R2 := K2.R;
     A := 2.0*M2X - 2.0*M1X;
     B := 2.0*M2Y - 2.0*M1Y;
     C := M2X*M2X - M1X*M1X + M2Y*M2Y - M1Y*M1Y + R1*R1 - R2*R2;
     In_Parameterform(A,B,C,PotH);
     PotLine := PotH;
   END;

PROCEDURE IntersectionCirles2D(K1,K2 : Circle; VAR Intsec : BOOLEAN;
                               VAR S1,S2 : Pt2D);
  VAR
  Nos : INTEGER;
  T1,T2 : EXTENDED;
  S1H,S2H : Pt2D;
  PotH : Line2D;
  BEGIN
    Intsec := FALSE;
    Chordale(K1,K2,PotH);
    IntersectionLineCircle(PotH,K1,NoS,T1,T2,S1H,S2H);
    NoSH := NoS;                                 (* nur fuer Beschriftung *)                  
    IF Nos > 0 THEN Intsec := TRUE;
    S1 := S1H; S2 := S2H;
  END;

PROCEDURE TtoXY(Kreis: Circle; T: EXTENDED; VAR X,Y: EXTENDED);
    BEGIN
      X := Kreis.M.X+Kreis.R*COS(T);           (* Umrechnung in           *)
      Y := Kreis.M.Y+Kreis.R*SIN(T);           (* Kartesische Koordinaten *)
    END;

PROCEDURE Zeichne_Kreis(Kreis: Circle; TMin,TMax: EXTENDED; TSteps : INTEGER);
   VAR
     I: INTEGER;
     X,Y,T,DeltaT: EXTENDED;
     P: Pt2D;
   BEGIN
     DeltaT := (TMax-TMin)/TSteps;
     T := TMin;                                         
     TtoXY(Kreis,T,X,Y);
     P.X := X; P.Y := Y;
     MoveToPt2D(P);
     FOR I := 0 TO TSteps DO
       BEGIN
         T := TMin + I*DeltaT;
         TtoXY(Kreis,T,X,Y);
         P.X := X; P.Y := Y;
         DrawLine2D(PLast,P,Col);
       END;        
    END;

PROCEDURE Zeichnen;
  VAR
  P1,P2: Pt2D;
  BEGIN
  TToLine2D(PotLine,13.0,P1);  TToLine2D(PotLine,25,P2);
  DrawLine2D(P1,P2,2);
  Zeichne_Kreis(K1,0.0,2*Pi+Eps,80);
  Zeichne_Kreis(K2,0.0,2*Pi+Eps,80);
  END;

PROCEDURE Eingabe;                
  BEGIN                         
  K1.M.X :=  1.6; K1.M.Y :=  0.4; K1.R := 7.2;
  K2.M.X := -4.8; K2.M.Y := -0.7; K2.R := 5.5;
  END;

{ -------------------------- main program -------------------------------- }
BEGIN
 Schnittstelle_waehlen(1);                 (* 2 bedeutet auf Datei plotten *)
  Plot := FALSE;                           (* 1 ist parallele Schnittst    *)
  einh := 1.0;   (* 1 Einheit auf der X-Achse und Y-Achse entspricht .. cm *)
  WI2D[1].X := -15.0;  WI2D[1].Y := -10.0;     (* linker unterer Punkt     *)
                                               (* des Weltfensters         *)
  Ausgangszustand_definieren;                 (* Graphikgrundeinstellung   *)
  Eingabe;
  Chordale(K1,K2,PotLine);
  IntersectionCirles2D(K1,K2,Intsec,S1,S2);
  Zeichnen;
  Beschriftung; 
  WClosegraph;
END.